json_grammar = {
    '<start>': [['<json>']],
    '<json>': [['<element>']],
    '<element>': [['<ws>', '<value>', '<ws>']],
    '<value>': [['<object>'], ['<array>'], ['<string>'], ['<number>'],
                ['true'], ['false'],
                ['null']],
    '<object>': [['{', '<ws>', '}'], ['{', '<members>', '}']],
    '<members>': [['<member>', '<symbol-2>']],
    '<member>': [['<ws>', '<string>', '<ws>', ':', '<element>']],
    '<array>': [['[', '<ws>', ']'], ['[', '<elements>', ']']],
    '<elements>': [['<element>', '<symbol-1-1>']],
    '<string>': [['"', '<characters>', '"']],
    '<characters>': [['<character-1>']],
    '<character>': [['0'], ['1'], ['2'], ['3'], ['4'], ['5'], ['6'], ['7'],
                    ['8'], ['9'], ['a'], ['b'], ['c'], ['d'], ['e'], ['f'],
                    ['g'], ['h'], ['i'], ['j'], ['k'], ['l'], ['m'], ['n'],
                    ['o'], ['p'], ['q'], ['r'], ['s'], ['t'], ['u'], ['v'],
                    ['w'], ['x'], ['y'], ['z'], ['A'], ['B'], ['C'], ['D'],
                    ['E'], ['F'], ['G'], ['H'], ['I'], ['J'], ['K'], ['L'],
                    ['M'], ['N'], ['O'], ['P'], ['Q'], ['R'], ['S'], ['T'],
                    ['U'], ['V'], ['W'], ['X'], ['Y'], ['Z'], ['!'], ['#'],
                    ['$'], ['%'], ['&'], ['\''], ['('], [')'], ['*'], ['+'],
                    [','], ['-'], ['.'], ['/'], [':'], [';'], ['<'], ['='],
                    ['>'], ['?'], ['@'], ['['], [']'], ['^'], ['_'], ['`'],
                    ['{'], ['|'], ['}'], ['~'], [' '], ['<esc>']],
    '<esc>': [['\\','<escc>']],
    '<escc>': [['\\'],['b'],['f'], ['n'], ['r'],['t'],['"']],
    '<number>': [['<int>', '<frac>', '<exp>']],
    '<int>': [['<digit>'], ['<onenine>', '<digits>'], ['-', '<digits>'],
              ['-', '<onenine>', '<digits>']],
    '<digits>': [['<digit-1>']],
    '<digit>': [['0'], ['<onenine>']],
    '<onenine>': [['1'], ['2'], ['3'], ['4'], ['5'], ['6'], ['7'], ['8'],
                  ['9']],
    '<frac>': [[], ['.', '<digits>']],
    '<exp>': [[], ['E', '<sign>', '<digits>'], ['e', '<sign>', '<digits>']],
    '<sign>': [[], ['+'], ['-']],
    '<ws>': [['<sp1>', '<ws>'], []],
    '<sp1>': [[' '],['\n'],['\t'],['\r']],
    '<symbol>': [[',', '<members>']],
    '<symbol-1>': [[',', '<elements>']],
    '<symbol-2>': [[], ['<symbol>', '<symbol-2>']],
    '<symbol-1-1>': [[], ['<symbol-1>', '<symbol-1-1>']],
    '<character-1>': [[], ['<character>', '<character-1>']],
    '<digit-1>': [['<digit>'], ['<digit>', '<digit-1>']]
}
